#!/usr/bin/env python3
#
# Copyright (c) 2024 Stormux
# Copyright (c) 2010-2012 The Orca Team
# Copyright (c) 2012 Igalia, S.L.
# Copyright (c) 2005-2010 Sun Microsystems Inc.
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the
# Free Software Foundation, Inc., Franklin Street, Fifth Floor,
# Boston MA  02110-1301 USA.
#
# Fork of Orca Screen Reader (GNOME)
# Original source: https://gitlab.gnome.org/GNOME/orca

from macaroon.playback import *
import utils

sequence = MacroSequence()

sequence.append(PauseAction(3000))
sequence.append(KeyComboAction("<Control>Home"))

sequence.append(utils.StartRecordingAction())
sequence.append(KeyComboAction("<Control>f"))
sequence.append(utils.AssertPresentationAction(
    "1. Ctrl+F",
    ["KNOWN ISSUE: We're double-presenting the combobox name",
     "BRAILLE LINE:  'soffice application Untitled 1 - LibreOffice Writer root pane Find tool bar  $l combo box'",
     "     VISIBLE:  'Find tool bar  $l combo box', cursor=15",
     "SPEECH OUTPUT: 'Find tool bar'",
     "SPEECH OUTPUT: 'Find Text Find Text editable combo box.'"]))

sequence.append(TypeAction("foo"))

sequence.append(utils.StartRecordingAction())
sequence.append(KeyComboAction("Tab"))
sequence.append(utils.AssertPresentationAction(
    "2. Tab",
    ["BRAILLE LINE:  'soffice application Untitled 1 - LibreOffice Writer root pane Find tool bar  $l combo box'",
     "     VISIBLE:  'Find Previous push button', cursor=1",
     "SPEECH OUTPUT: 'Find Previous push button'"]))

sequence.append(utils.StartRecordingAction())
sequence.append(KeyComboAction("<Shift>ISO_Left_Tab"))
sequence.append(utils.AssertPresentationAction(
    "3. Shift+Tab",
    ["BRAILLE LINE:  'soffice application Untitled 1 - LibreOffice Writer root pane Find tool bar Find Previous push button'",
     "     VISIBLE:  'foo $l combo box', cursor=4",
     "SPEECH OUTPUT: 'Find Text Find Text editable combo box.'",
     "SPEECH OUTPUT: 'foo selected'"]))

sequence.append(KeyComboAction("<Alt>F4"))

sequence.append(utils.AssertionSummaryAction())
sequence.start()
